﻿// Keep these lines for a best effort IntelliSense of Visual Studio 2017 and higher.
/// <reference path="./../../Packages/Beckhoff.TwinCAT.HMI.Framework.12.752.0/runtimes/native1.12-tchmi/TcHmi.d.ts" />
(function (/** @type {globalThis.TcHmi} */ TcHmi) {
    var Functions;
    (function (/** @type {globalThis.TcHmi.Functions} */ Functions) {
        var BigArrayManipulation;
        (function (BigArrayManipulation) {
            function RefreshGridViewWithPLC(GridControl) {
				console.log('Calling RefreshGridViewWithPLC');
				var readData;
				async function asyncCall() {
					readData = await ReadServerData('%s%PLC1.MAIN.bigData%/s%');
					gtotalPLCLength = readData.length;
						var listBoxData = [];
						for (var i = 0; i < gtotalPLCLength; i++) {
							var emptyObject = {
								boolData: false,
								stringData: '',
								Day1: false,
								Day2: false,
								Day3: false,
								Day4: false,
								Day5: false
							};

							emptyObject.boolData = readData[i].boolData;
							emptyObject.stringData = readData[i].stringData;
							emptyObject.Day1 = readData[i].ArrayDataFirstDays[0];
							emptyObject.Day2 = readData[i].ArrayDataFirstDays[1];
							emptyObject.Day3 = readData[i].ArrayDataFirstDays[2];
							emptyObject.Day4 = readData[i].ArrayDataFirstDays[3];
							emptyObject.Day5 = readData[i].ArrayDataFirstDays[4];
							listBoxData.push(emptyObject);
						}
						GridControl.setSrcData(listBoxData);
				}
				try {
					var emptyError = [];
					GridControl.setSrcData(emptyError);
					asyncCall();

				} catch (error) {
					console.log(`ErrorCode Calling RefreshGridViewWithPLC = ${error}`);
                }
            }
            BigArrayManipulation.RefreshGridViewWithPLC = RefreshGridViewWithPLC;
        })(BigArrayManipulation = Functions.BigArrayManipulation || (Functions.BigArrayManipulation = {}));
        Functions.registerFunctionEx('RefreshGridViewWithPLC', 'TcHmi.Functions.BigArrayManipulation', BigArrayManipulation.RefreshGridViewWithPLC);
    })(Functions = TcHmi.Functions || (TcHmi.Functions = {}));
})(TcHmi);